SystemOrganization addCategory: #'Comet-Platform'!
SystemOrganization addCategory: #'Comet-Core'!
SystemOrganization addCategory: #'Comet-Examples'!

!SeasidePlatformSupport class methodsFor: '*comet-squeak' stamp: 'lr 10/28/2007 14:45'!
addToShutDownList: anObject
	Smalltalk addToShutDownList: anObject! !

!SeasidePlatformSupport class methodsFor: '*comet-squeak' stamp: 'lr 10/28/2007 14:45'!
addToStartUpList: anObject after: another
	Smalltalk addToStartUpList: anObject after: another! !

!SeasidePlatformSupport class methodsFor: '*comet-squeak' stamp: 'mb 10/5/2006 11:47'!
terminateProcess: aProcess
	^aProcess terminate! !

!SeasidePlatformSupport class methodsFor: '*comet-squeak' stamp: 'lr 10/28/2007 14:45'!
withName: aString withPriority: anInteger fork: aBlock
	^aBlock forkAt: anInteger named: aString! !

SeasideAddonVWInfo subclass: #CometVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Platform'!

!CometVWInfo class methodsFor: 'accessing' stamp: 'mb 10/16/2006 17:58'!
addonName
	^'Comet'! !

!WARenderCanvas methodsFor: '*comet' stamp: 'lr 7/12/2006 12:17'!
comet
	^ CTComet on: self! !

WAFileLibrary subclass: #CTLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

!CTLibrary methodsFor: 'scripts' stamp: 'lr 10/28/2007 14:45'!
cometJs
	^ '/* Seaside Comet API
 *  (c) 2006 Lukas Renggli (renggli@iam.unibe.ch)
 */

Comet = Class.create();
Comet.prototype = {
	initialize: function (url, options) {
		this.url = url;
		this.options = Object.extend({
			reconnect: false
		}, options || {});
		this.iframe = document.createElement("iframe");
		this.iframe.style.visibility = "hidden";
		this.iframe.style.width = this.iframe.style.height = this.iframe.style.border = "0";
		document.getElementsByTagName("body")[0].appendChild(this.iframe);
	},
	connect: function() {
		this.iframe.onLoad = this.onLoad.bind(this);
		this.iframe.src = this.url;
	},
	disconnect: function() {
		this.iframe.onLoad = Prototype.emptyFunction;
		this.iframe.src = "about:blank";
	},
	onLoad: function() {
		this.disconnect();
		if (this.options.reconnect)
			this.connect();
	}
};
Comet.eval = function(code) { return eval(code); };'! !

!CTLibrary methodsFor: 'accessing' stamp: 'lr 1/2/2008 20:11'!
selectorsToInclude
	^ #( cometJs )! !

SUPrototype subclass: #CTComet
	instanceVariableNames: 'pusher url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

!CTComet class methodsFor: 'configuration' stamp: 'lr 7/12/2006 12:10'!
headerField
	^ '_c'! !

!CTComet class methodsFor: 'configuration' stamp: 'lr 7/12/2006 12:10'!
terminator
	^ Character value: 0! !

!CTComet methodsFor: 'actions' stamp: 'lr 7/3/2006 13:54'!
connect
	self call: 'connect'! !

!CTComet methodsFor: 'private' stamp: 'lr 5/28/2006 22:00'!
defaultArguments
	^ (Array with: self url) , super defaultArguments! !

!CTComet methodsFor: 'private' stamp: 'lr 5/28/2006 22:07'!
defaultPrototype
	^ 'Comet'! !

!CTComet methodsFor: 'private' stamp: 'lr 7/12/2006 12:10'!
defaultUrl
	^ self canvas context actionUrl
		addParameter: self class headerField
		value: self pusher id! !

!CTComet methodsFor: 'actions' stamp: 'lr 7/3/2006 13:54'!
disconnect
	self call: 'disconnect'! !

!CTComet methodsFor: 'initialization' stamp: 'lr 7/3/2006 13:33'!
initialize
	super initialize.
	self create! !

!CTComet methodsFor: 'accessing' stamp: 'lr 7/3/2006 13:44'!
pusher
	^ pusher! !

!CTComet methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:45'!
pusher: aPusher
	self url: (self canvas context actionUrl
		withParameter: self class headerField
		value: (self session
			registerPusher: (pusher := aPusher)
			context: self canvas context))! !

!CTComet methodsFor: 'options' stamp: 'lr 7/3/2006 13:37'!
reconnect: aBoolean
	self optionAt: 'reconnect' put: aBoolean! !

!CTComet methodsFor: 'accessing' stamp: 'lr 7/3/2006 13:33'!
url
	^ url ifNil: [ url := self defaultUrl ]! !

!CTComet methodsFor: 'accessing' stamp: 'lr 7/3/2006 13:34'!
url: anUrl
	url := anUrl! !

WAComponent subclass: #CTChat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTChat class
	instanceVariableNames: 'pusher'!

CTChat class
	instanceVariableNames: 'pusher'!

!CTChat class methodsFor: 'initialization' stamp: 'lr 1/2/2008 18:03'!
initialize
	| application |
	application := self registerAsApplication: 'comet/chat'.
	application preferenceAt: #sessionClass put: CTChatSession.
	application addLibrary: SULibrary; addLibrary: CTLibrary! !

!CTChat class methodsFor: 'accessing' stamp: 'lr 1/2/2008 17:58'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTChat methodsFor: 'testing' stamp: 'lr 1/2/2008 19:00'!
isLoggedIn
	^ self username notNil! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 20:01'!
login: aString
	"Join the chat-room with the given username aString."
	
	aString isEmptyOrNil ifTrue: [ ^ self ].
	self session username: aString.
	self push: 'event' with: 'joined'! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 20:01'!
logout
	"Leave the chat-room."

	self push: 'event' with: 'left'.
	self session username: nil! !

!CTChat methodsFor: 'actions' stamp: 'lr 1/2/2008 19:35'!
message: aString
	"Send the message aString to the chat-room."
	
	self push: 'message' with: aString! !

!CTChat methodsFor: 'private' stamp: 'lr 1/2/2008 20:06'!
push: aString with: aBlock
	self pusher javascript: [ :script |
		script element id: 'messages'; insertTop: [ :html |
			self renderMessage: aBlock class: aString on: html ] ]! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:37'!
pusher
	^ self class pusher! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 19:00'!
renderChatInputOn: html
	html textArea
		id: 'input';
		callback: [ :value | self message: value ];
		onEnter: (html request
			triggerFormElement: 'input';
			onSuccess: (html formElement
				id: 'input';
				clear))! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 20:05'!
renderChatMessagesOn: html
	html div id: 'messages'; with: [
		self 
			renderMessage: [
				self users isEmpty
					ifTrue: [ html text: 'You are the only one here!!' ]
					ifFalse: [
						html text: 'Also there: '.
						self users
							do: [ :each | html text: each ]
							separatedBy: [ html text: ', ' ] ] ]
			class: 'event' on: html ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 19:44'!
renderChatOn: html
	self renderChatStatusOn: html.
	self renderChatMessagesOn: html.
	self renderChatInputOn: html.
	self renderChatPusherOn: html! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 18:44'!
renderChatPusherOn: html
	html script: (html comet
		pusher: self pusher;
		connect)! !

!CTChat methodsFor: 'rendering-chat' stamp: 'lr 1/2/2008 19:56'!
renderChatStatusOn: html
	html div id: 'status'; with: [
		html text: 'Currently logged in as ' , self username , '. '.
		html anchor
			callback: [ self logout ];
			with: 'Logout' ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 18:38'!
renderContentOn: html
	html heading: 'Seaside Chat'.
	self isLoggedIn
		ifTrue: [ self renderChatOn: html ]
		ifFalse: [ self renderLoginOn: html ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 18:52'!
renderLoginOn: html
	html form: [
		html textInput
			value: self username;
			callback: [ :value | self login: value ].
		html submitButton
			text: 'Login' ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 20:05'!
renderMessage: aBlock class: aString on: html
	html div class: 'message'; with: [
		html span class: 'user'; with: self username.
		html span class: aString; with: aBlock ]! !

!CTChat methodsFor: 'rendering' stamp: 'lr 1/2/2008 19:39'!
style
	^ '#status {
	background-color: #eee;
}
#messages {
	height: 10em;
	overflow: auto;
}
#messages .message {
	margin-top: 0.25em;
	margin-bottom: 0.25em;
}
#messages .message .user {
	font-weight: bold;
	margin-right: 1em;
}
#messages .message .event {
	font-style: italic;
}
#input {
	width: 100%;
	background-color: #eee;
}'! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:38'!
username
	^ self session username! !

!CTChat methodsFor: 'accessing' stamp: 'lr 1/2/2008 20:01'!
users
	^ (self pusher handlers
		reject: [ :each | self session == each session or: [ each session username isNil ] ])
		collect: [ :each | each session username ]! !

WAComponent subclass: #CTCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

CTCounter class
	instanceVariableNames: 'model pusher'!

CTCounter class
	instanceVariableNames: 'model pusher'!

!CTCounter class methodsFor: 'initialization' stamp: 'lr 1/2/2008 16:34'!
initialize
	| application |
	application := self registerAsApplication: 'comet/counter'.
	application preferenceAt: #sessionClass put: CTSession.
	application addLibrary: SULibrary; addLibrary: CTLibrary! !

!CTCounter class methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:01'!
model
	^ model ifNil: [ model := CTCounterModel new ]! !

!CTCounter class methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:01'!
pusher
	^ pusher ifNil: [ pusher := CTPusher new ]! !

!CTCounter methodsFor: 'actions' stamp: 'lr 1/2/2008 17:08'!
decrease
	self model decrease.
	self update: #decrease! !

!CTCounter methodsFor: 'actions' stamp: 'lr 1/2/2008 17:08'!
increase
	self model increase.
	self update: #increase! !

!CTCounter methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:38'!
model
	^ self class model! !

!CTCounter methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:38'!
pusher
	^ self class pusher! !

!CTCounter methodsFor: 'rendering' stamp: 'lr 1/2/2008 16:44'!
renderContentOn: html
	html heading
		id: 'count';
		with: self model count.
	html anchor
		onClick: (html request callback: [ self increase ]);
		with: '++'.
	html space.
	html anchor
		onClick: (html request callback: [ self decrease ]);
		with: '--'.
	html script: (html comet
		pusher: self pusher;
		connect)! !

!CTCounter methodsFor: 'private' stamp: 'lr 1/2/2008 17:43'!
update: anAspect
	"Update the number in all connected web browser. Only the first 4 lines are really needed, the rest adds some eye-candy and can simply be removed if not needed."

	self pusher javascript: [ :script |
		script element
			id: 'count';
			update: self model count.
		script element
			id: 'count';
			insertBottom: [ :html |
				html span id: 'trend'; with: [
					html html: (anAspect = #increase
						ifTrue: [ '&uarr;' ]
						ifFalse: [ '&darr;' ]) ] ].
		script effect
			id: 'trend';
			fade ]! !

WASession subclass: #CTSession
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

CTSession subclass: #CTChatSession
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

!CTChatSession methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:07'!
username
	^ username! !

!CTChatSession methodsFor: 'accessing' stamp: 'lr 1/2/2008 18:06'!
username: aString
	username := aString! !

!CTSession methodsFor: 'processing' stamp: 'lr 8/30/2006 12:04'!
cometRequest: aRequest
	^ (handlers
		at: (aRequest fields
			at: CTComet headerField
			ifAbsent: [ ^ nil ])
		ifAbsent: [ ^ nil ])
			connect: aRequest! !

!CTSession methodsFor: 'processing' stamp: 'lr 7/12/2006 12:10'!
incomingRequest: aRequest
	aRequest responseStream
		ifNil: [ self error: 'Streaming-server required.' ].
	^ (aRequest fields includesKey: CTComet headerField)
		ifTrue: [ self cometRequest: aRequest ]
		ifFalse: [ super incomingRequest: aRequest ]! !

!CTSession methodsFor: 'initialize-release' stamp: 'mb 3/14/2007 11:44'!
initialize
	super initialize.
	handlers := Dictionary new! !

!CTSession methodsFor: 'public' stamp: 'lr 8/30/2006 11:57'!
registerPusher: aPusher context: aContext
	| handler |
	handler := CTHandler on: aPusher session: self context: aContext.
	handlers at: handler id put: handler.
	^ handler id! !

Object subclass: #CTCounterModel
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

!CTCounterModel class methodsFor: 'instance creation' stamp: 'lr 1/2/2008 16:36'!
new
	^ self basicNew initialize! !

!CTCounterModel methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:36'!
count
	^ count! !

!CTCounterModel methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:43'!
count: anInteger
	count := anInteger! !

!CTCounterModel methodsFor: 'actions' stamp: 'lr 1/2/2008 16:33'!
decrease
	count := count - 1! !

!CTCounterModel methodsFor: 'actions' stamp: 'lr 1/2/2008 16:33'!
increase
	count := count + 1! !

!CTCounterModel methodsFor: 'initialization' stamp: 'lr 1/2/2008 16:36'!
initialize
	count := 0! !

Object subclass: #CTHandler
	instanceVariableNames: 'id pusher socket session context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

!CTHandler class methodsFor: 'instance creation' stamp: 'lr 8/30/2006 11:56'!
on: aPusher session: aSession context: aContext
	^ self basicNew initializeOn: aPusher session: aSession context: aContext! !

!CTHandler methodsFor: 'private' stamp: 'cb 7/18/2007 13:22'!
basicConnect: aRequest
	| root |
	socket := aRequest responseStream socket.
	socket pushData: (String streamContents: [ :stream |
		root := WAHtmlRoot context: context.
		WAResponse new
			contentType: 'text/html; charset=utf-8';
			headerAt: 'Expires' put: 'Thu, 11 Jun 1980 12:00:00 GMT';
			headerAt: 'Cache-Control' put: 'no-cache, must-revalidate';
			headerAt: 'Pragma' put: 'no-cache';
			contents: (String streamContents: [ :contents |
				WACurrentSession
					use: session
					during: [ session updateRoot: root. root open: (WAHtmlStreamDocument new stream: contents) ].
				contents nextPutAll: (String new: 1024 withAll: Character space) ]);
			writeOn: stream ])! !

!CTHandler methodsFor: 'private' stamp: 'lr 7/12/2006 14:33'!
basicDisconnect
	socket ifNil: [ ^ self ].
	socket destroy.
	socket := nil! !

!CTHandler methodsFor: 'private' stamp: 'lr 10/28/2007 14:45'!
basicTerminate
	thisContext swapSender: nil.
	Processor activeProcess terminate! !

!CTHandler methodsFor: 'actions' stamp: 'lr 10/28/2007 14:45'!
connect: aRequest
	self
		basicDisconnect;
		basicConnect: aRequest.
	self pusher register: self.
	self basicTerminate! !

!CTHandler methodsFor: 'accessing' stamp: 'lr 7/12/2006 11:22'!
id
	^ id! !

!CTHandler methodsFor: 'initialization' stamp: 'lr 8/30/2006 11:56'!
initializeOn: aPusher session: aSession context: aContext
	id := WAExternalID new asString.
	pusher := aPusher.
	session := aSession.
	context := aContext! !

!CTHandler methodsFor: 'actions' stamp: 'lr 8/30/2006 12:11'!
push: aString
	socket ifNil: [ ^ false ].
	^ socket pushData: aString! !

!CTHandler methodsFor: 'accessing' stamp: 'lr 7/12/2006 14:24'!
pusher
	^ pusher! !

!CTHandler methodsFor: 'accessing' stamp: 'lr 8/30/2006 11:32'!
session
	^ session! !

Object subclass: #CTPusher
	instanceVariableNames: 'mutex handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

CTPusher class
	instanceVariableNames: 'process delay'!

CTPusher class
	instanceVariableNames: 'process delay'!

!CTPusher class methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:45'!
initialize
	SeasidePlatformSupport
		addToStartUpList: self after: WAListener;
		addToShutDownList: self.
	self startUp! !

!CTPusher class methodsFor: 'instance creation' stamp: 'lr 1/2/2008 17:23'!
new
	^ self basicNew initialize! !

!CTPusher class methodsFor: 'private' stamp: 'lr 8/30/2006 10:25'!
pingProcess
	self allInstancesDo: [ :each | each ping ].
	delay wait! !

!CTPusher class methodsFor: 'initialization' stamp: 'mb 10/5/2006 11:48'!
shutDown
	process ifNil: [ ^ self ].
	SeasidePlatformSupport terminateProcess: process.
	process := nil! !

!CTPusher class methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:45'!
startUp
	self shutDown.
	delay := Delay forSeconds: 15.
	process := SeasidePlatformSupport
		withName: 'ping' withPriority: 20
		fork: [ [ self pingProcess ] repeat ]! !

!CTPusher methodsFor: 'accessing' stamp: 'lr 1/2/2008 16:56'!
canvas
	"Answer a fake rendering canvas for this pusher."
	
	^ WARenderCanvas 
		context: WARenderingContext new
		callbacks: Dictionary new! !

!CTPusher methodsFor: 'accessing' stamp: 'lr 7/12/2006 11:50'!
handlers
	"Answer the current list of handlers."

	^ handlers! !

!CTPusher methodsFor: 'initialization' stamp: 'mb 10/5/2006 14:57'!
initialize
	mutex := Semaphore forMutualExclusion.
	handlers := Array new! !

!CTPusher methodsFor: 'public' stamp: 'lr 1/2/2008 16:57'!
javascript: aBlock
	"Evaluate aBlock with an SUScript instance and pushes the resulting script-string aString to all associated handlers."
	
	| script |
	aBlock value: (script := SUScript on: self canvas).
	self push: (String streamContents: [ :stream |
		stream
			nextPutAll: '<script type="text/javascript">parent.Comet.eval(';
			javascript: script asJavascript;
			nextPutAll: ')</script>' ])! !

!CTPusher methodsFor: 'accessing' stamp: 'lr 7/12/2006 15:01'!
mutex
	"Answer the mutex in use with the reciever."

	^ mutex! !

!CTPusher methodsFor: 'protected' stamp: 'lr 8/30/2006 11:15'!
ping
	"Ping all the associated handlers."

	self mutex critical: [ handlers := handlers select: [ :each | each push: ' ' ] ]! !

!CTPusher methodsFor: 'protected' stamp: 'mb 10/26/2006 12:10'!
push: aString
	"Push aString to all associated handlers."

	handlers do: [ :each | each push: aString ]! !

!CTPusher methodsFor: 'protected' stamp: 'lr 8/30/2006 10:43'!
register: aHandler
	"Register a new handler into this pusher."

	mutex critical: [ handlers := handlers copyWith: aHandler ]! !

!WriteStream methodsFor: '*comet-squeak' stamp: 'lr 7/3/2006 14:14'!
crlf
	self nextPutAll: String crlf! !

!Socket methodsFor: '*comet-squeak' stamp: 'lr 10/28/2007 14:45'!
pushData: aStringOrByteArray
	"Send aStringOrByteArray to the remote host trough the given socket. Push the data immediately and ignore all kinds of errors. Return true if all the data could be sent successfully, in case of problems return false and destroy the socket."

	| bytesSent bytesToSend count |
	bytesSent := 0.
	bytesToSend := aStringOrByteArray size.
	[ [ bytesSent < bytesToSend ] whileTrue: [
		count := self
			primSocket: socketHandle
			sendData: aStringOrByteArray
			startIndex: bytesSent + 1
			count: (bytesToSend - bytesSent min: 5000).
		bytesSent := bytesSent + count.
		(count = 0 and: [ bytesSent ~= bytesToSend ])
			ifTrue: [ self destroy. ^ false ] ] ]
		on: Error do: [ self destroy. ^ false ].
	^ true! !
CTChat initialize!
CTCounter initialize!
CTPusher initialize!
